M = 10
N = 12
g = [2, 3, 0, 1, 8, 9]
d = [4, 6, 7, 5, 9, 10]
h = [4, 5, 2, 3, 4, 3]

def remplir(g, h, d):
    nb = len(g)
    E = [0]*M
    for i in range(M):
        E[i] = [0]*N
    for k in range(nb):
        for j in range(g[k], d[k]):
            for i in range(h[k]):
                E[i][j] = 1
    return E
        
def horizon1(E):
    hor = [0]
    for k in range(N):
        h = 0
        while h < M and E[h][k] == 1:
            h = h + 1
        hor.append(h)
        hor.append(k+1)
    return hor

def horizon2(E):
    hor = [0]
    h = 0
    for k in range(N):
        h = 0
        while h < M and E[h][k] == 1:
            h = h + 1
        while h > 0 and E[h-1][k] == 0:
            h = h - 1
        hor.append(h)
        hor.append(k+1)
    return hor

def canonique(hor):
    n = len(hor)
    can = [hor[0]]
    p = 2
    while p < n and hor[p] == hor[0]:
        p = p + 2
    while p < n:
        h = hor[p-1]
        can.append(h)
        while p + 2 < n and (hor[p+2] == hor[p] or hor[p+1] == h):
           p = p + 2
        can.append(hor[p])
        p = p + 2
    return can

def fusion(hor1, hor2):
    n = len(hor1) + len(hor2) - 3
    fus = [0]*(n) 
    k1 = 2
    k2 = 2
    for i in range(1, n, 2):
        h = max(hor1[k1-1], hor2[k2-1])
        fus[i] = h
        if hor1[k1] < hor2[k2]:
            fus[i+1] = hor1[k1]
            k1 = k1 + 2
        else:
            fus[i+1] = hor2[k2]
            k2 = k2 + 2
    return fus
   

E = remplir(g, h, d)
print(horizon2(E))
    
            
    